/*
 *  SMTPproxy.h
 *  econsend
 *
 *  Created by Raymond Doetjes on 6/6/05.
 *  Copyright 2005 Phonax.com. All rights reserved.
 *  email: rdoetjes@phonax.com
 */

#include "Socket.h"
#include <string>

#define HELO 0
#define MAILFROM 1
#define RCPTTO 2
#define DATA 3
#define DOT 4
#define DONE 5
#define BOUNCE 6
#define BODY_OKAY 7

#define BUFFSIZE 4096

//: SMTP
class SMTPproxy 
{
  public:
    SMTPproxy(Socket* csock, string id);
	~SMTPproxy();
	void Run(int (*from)(string sMailFrom), int (*rcptto)(string sRcptTo), int (*body)(string sBody), void(*email)(string sEmail), int sec_smtp_port=15010);	
	bool CmdCompare(string cmd, string cmp);
	string getEmailAdres(string cmd);
	string getDomainName(string cmd);
  private:
    Socket *sock;
    bool checkResult(const char *reponse);
};
