#include <fstream>
#include <iostream>
#include <sys/types.h>
#include <netinet/in.h>
#include <string>
#include <sys/socket.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <fcntl.h>
#include <signal.h>
#include <netdb.h>
#include <errno.h>

#ifndef SOCKET_H
#define SOCKET_H

using namespace std;

class Socket 
{
  public:
    Socket(int fd=0, char *host="127.0.0.1", int port=1024, string sRemark="");
    ~Socket();
    int Connect();
    int WriteLine(char *data, FILE *rcv);
    int ReadLine(char *, int maxlen);
    int Read(char *, int len);
    int Send(char *, int len);
	int Send(string data);
    int sendFile(char *file, int buffer=4096);
    void setTimeOut(int timeout);
    int fdRdySend(int sec, int usec);
    int fdRdyRead(int sec, int usec);
    int fdRdy(int sec, int usec);
    void Close();
    void setSocket(int fd);
    void setRemark(string sRemark="");
    string getRemark();
    void nonBlocking();
    int getSocket();
    bool Connected();
    int Reconnect();
    int reconnect;
    int Peek(char *data, int len);

  private:
    int sock;
    string Remark;
    struct sockaddr_in s;
    struct hostent *hp;
    socklen_t len;
    fd_set fdw;
    fd_set fdr;
    struct timeval tv;
    struct timeval to;
    struct sigaction act;
    void calcTimeOut(float timeout, int *sec, int *usec);
    bool isConnected;
};
#endif
