/*
 *  emailHandling.cpp
 *  eProxy
 *
 *  Created by Raymond Doetjes on 8/18/06.
 *  Copyright 2006 Phonax.com. All rights reserved.
 *  email: rdoetjes@phonax.com
 */

#include "emailHandling.h"

string getDomainName(string email)
{
  string result("");
  
  int bpos=0;
  bpos=email.find("@", 0);
  result=email.substr(bpos+1, email.length());
  return result;
}

bool isLocalUser(string email)
{
  bool result=true;
  return result;
}

int from(string from)
{
  int result=-1;
  
  writeSyslog("eProxy(MAILFROM handler)", LOG_WARNING, LOG_SYSLOG, "starting MAIL FROM handler function");
  transform(from.begin(),from.end(), from.begin(), (int(*)(int)) tolower);
  if (from.find("@hotmail.com", 0)!=string::npos) // if email is being send form hotmail.com than cancel the transaction
    result=-1; 
  else
    result=1;
  writeSyslog("eProxy(MAILFROM handler)", LOG_WARNING, LOG_SYSLOG, "ending MAIL FROM handler function");
  return result;
}

int rcptto(string to)
{
  int result=-1;
  
  writeSyslog("eProxy(RCPTTO handler)", LOG_WARNING, LOG_SYSLOG, "starting RCPT TO handler function");
  transform(to.begin(),to.end(), to.begin(), (int(*)(int)) tolower);
  if (to.find("p@phonax.com", 0)!=string::npos) // if the email is being send to p@phonax.com than the transaction is cancled
    result=-1;
  else
    result=1;
  writeSyslog("eProxy(RCPTTO handler)", LOG_WARNING, LOG_SYSLOG, "ending RCPT TO handler function");
  return result;
}

int body(string body)
{
  int result=-1;
  
  writeSyslog("eProxy(BODY handler)", LOG_WARNING, LOG_SYSLOG, "starting BODY handler function");
  if (body.find("censor")!=string::npos) // if the word censor occurs than the email is disgarded
    result=-1;
  else
    result=1; //okay
  writeSyslog("eProxy(BODY handler)", LOG_WARNING, LOG_SYSLOG, "ending BODY handler function");  
  return result;
}

void email(string email)
{
  writeSyslog("eProxy(EMAIL handler)", LOG_WARNING, LOG_SYSLOG, "starting EMAIL handler function");
  //You can put code here to forinstance save the complete email in a database or something...
  writeSyslog("eProxy(EMAIL handler)", LOG_WARNING, LOG_SYSLOG, "ending EMAIL handler function");
}
