#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <fcntl.h>
#include <signal.h>

class serverSocket 
{
  public:
    serverSocket(int port=65000, u_long addr=INADDR_ANY);
    ~serverSocket();
    int startListener(bool nonblocking=false, bool manual=false);
    int Accept(void);
    int Listen(int backlog);
    int Bind(void);
    void nonBlocking(void);
    bool fdRdySend(int fd);
    bool fdRdyRead(int fd);
    void Close(int sock);
    int srvSocket;
    int srvPort;
    int srvBacklog;
    u_long  bindAddr;

    //These int's are used for sockoptions
    int ReuseAddr; //default set to on
    int ReusePort; //default set to on

  private:
    socklen_t len;
    struct sockaddr_in srvAddr, clntAddr;
    fd_set fdw;
    fd_set fdr;
    struct timeval tv;
};
